from metaservicesynced.apiviews import *
from rest_framework import routers
from django.urls import path, include

router = routers.DefaultRouter()
router.register(r'client', ClientMVS)
router.register(r'company', CompanyMVS)
router.register(r'documents', DocumentsMVS)
router.register(r'orders', OrdersMVS)
router.register(r'permissions', PermissionsMVS)
router.register(r'provider', ProviderMVS)
router.register(r'relationship', RelationshipMVS)
router.register(r'resource', ResourceMVS)
router.register(r'service', ServiceMVS)
router.register(r'servicetype', ServiceTypeMVS)
router.register(r'personinfo', PersonInfoMVS)
router.register(r'frequentaddress', FrequentaddressMVS)
router.register(r'favoritecontacts', FavoritecontactsMVS)
router.register(r'preferreddrivers', PreferreddriversMVS)
urlpatterns = [  
    path('api/', include(router.urls), name="metasynced"),
]